/*
  Le Speech SDK 5.1 est requis pour compiler cette dll.

  Avec VC6 crez un projet "Dynamic Link Library" nomm speech dans
  le dossier Program Files\Microsoft Speech SDK 5.1\Samples\CPP.

  Dans le menu Project/Project Settings/ C/C++ Project, dans le
  Combo "Category" choisir "PreProcessor" et ajouter dans
  "Additionnal Include Directories" ..\..\..\include

  Puis Onglet Link/Project Options: ajouter /libpath:"..\..\..\Lib\i386"
*/

#include <stdio.h>
#include <sapi.h>
#include <tchar.h>
#include <atlbase.h>

_declspec (dllexport) void say(char *str)
{
  ISpVoice * pVoice = NULL;

  if (FAILED(::CoInitialize(NULL))) return;

  HRESULT hr = CoCreateInstance(CLSID_SpVoice, NULL, CLSCTX_ALL, IID_ISpVoice, (void **)&pVoice);
  if( SUCCEEDED(hr))
  {
	//pVoice->SetRate(-3);

	wchar_t ws[512];
	swprintf( ws, L"%S", str );

	hr = pVoice->Speak(ws, SPF_IS_XML, NULL );
    pVoice->Release();
    pVoice = NULL;
  }

  ::CoUninitialize();
}


/*
  On peut changer les paramtres de la voix

	// Par dfaut:
    //hr = pVoice->Speak(L"Hello world", 0, NULL);

	// Changer pitch, avec balise XML
    //hr = pVoice->Speak(L"This sounds normal <pitch middle = '-10'/> but the pitch drops half way through", SPF_IS_XML, NULL );

	// Voix plus grave (le "rate" va de -10  10)
	//hr = pVoice->Speak(L"<rate speed='-3'/>You have 42 messages.!", SPF_IS_XML, NULL );

    // mme effet mais sans XML:
	pVoice->SetRate(-3);
	hr = pVoice->Speak(L"you have 42 messages.", 0, NULL );
 
	// Amliore la qualit en 44kHz 16Bit Stereo
	SPSTREAMFORMAT eFmt = SPSF_44kHz16BitStereo;
    CSpStreamFormat Fmt;
    Fmt.AssignFormat(eFmt);
	
    hr = m_cpOutAudio->SetFormat( Fmt.FormatId(), Fmt.WaveFormatExPtr() );
    hr = pVoice->SetOutput( m_cpOutAudio, FALSE );
*/
