#include "junk.h"

/*==============================================================================
  Lit le fichier junk pour initialiser le tableau de structures
==============================================================================*/
void junk_Lire_Infos_Stockees()
{
  FILE *pF;
  char *t;
  boite y;
  int n;

  pF = fopen("junk","rb");
  if (!pF) // si premire utilisation
  {
     dire("Hello, This is the first time you are using the program."
          "Please add some mailboxes I will connect to.");
     return;
  }

  // lit le nombre de boites  charger
  fread(&nbboites,sizeof(int),1,pF);

  // alloue l'espace au tableau
  b = (boite*)calloc(nbboites, sizeof(boite));
  c = (check*)calloc(nbboites, sizeof(check));

  // et le remplit en lisant les boites
  for (n=0; n<nbboites; n++)
  {
    fread(&y,sizeof(boite),1,pF);
    t = f(VERSION, y.serv); strcpy(b[n].serv,t); free(t);
    t = f(VERSION, y.n   ); strcpy(b[n].n   ,t); free(t);
    t = f(VERSION, y.p   ); strcpy(b[n].p   ,t); free(t);
    t = f(VERSION, y.nom ); strcpy(b[n].nom ,t); free(t);
    b[n].port       = y.port;
    b[n].intervalle = y.intervalle;

    c[n].next_check = 1;
    c[n].nbmessages = -1;
  }
  close(pF);
}

/*==============================================================================
  Passe le tableau de structure dans le fichier junk
==============================================================================*/
void junk_Ecrire_Fichier()
{
  FILE *pF;
  boite w;
  char *t;
  int n;

  pF = fopen("junk","wb");
       fwrite(&nbboites,sizeof(int),1,pF);

  for(n=0; n<nbboites; n++)
  {
    t = u(VERSION, b[n].serv); sprintf(w.serv, "%s", t); free(t);
    t = u(VERSION, b[n].n   ); sprintf(w.n   , "%s", t); free(t);  
    t = u(VERSION, b[n].p   ); sprintf(w.p   , "%s", t); free(t);
    t = u(VERSION, b[n].nom ); sprintf(w.nom , "%s", t); free(t);
    w.port       = b[n].port;
    w.intervalle = b[n].intervalle;
    fwrite(&w,sizeof(boite),1,pF);
  }
  fclose(pF);
}

/*==============================================================================
 Traitement de chane de caractres
==============================================================================*/
static char *u (char *str, char *s)
{
  int len, slen, i=0, n=0, k=0;
  char *out;

  len  = strlen(str);
  slen = strlen(s);
  out  = malloc(slen+1);

  while(*s)
  {
    n = *s + str[i];
    if (n > 255) n = 256 - n;
    out[k++]=n;
    *s++; i++; if (i==len) i=0;
  }
  out[slen]=0;
  return out;
}

/*==============================================================================
 Traitement de chane de caractres
==============================================================================*/
static char *f (char *str, char *s)
{
  int len, slen, i=0, n=0, k=0;
  char *out;

  len  = strlen(str);
  slen = strlen(s);
  out  = malloc(slen+1);

  while(*s)
  {
    n = *s - str[i];
    if (n <0) n = 256 + n;
    out[k++]=n;
    *s++; i++; if (i==len) i=0;
  }
  out[slen]=0;
  return out;
}
